`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: Kyushu Institute of Technology
// Engineer: DSP Lab
// 
// Create Date:    13:48:25 09/06/2017 
// Design Name: Neural Network (using backpropagation)
// Module Name:    counter
// Project Name: LSI Design Contest in Okinawa 2018
// Target Devices: 
// Tool versions: 
//
// Description: 
// 	counter for signal to insert in k1, k2, t1 and t2
// Input:
//		clk				: 1 bit
//		reset 			: 1 bit : high active
// Output: 
//		out				: 4 bit : high active
// Latency:
// 
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Name : date : what changed
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module counter (  input clk,
                  input reset,
                  output reg [3:0] out);
  parameter N=13;
  
  always @ (posedge clk) begin
    if (reset==1)
      out <= 0;
    else if(out==(N-1))
      out <= 0;
    else 
      out <= out + 1;
  end
endmodule 