`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    22:00:09 10/10/2017 
// Design Name: 
// Module Name:    db_adder 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module db_adder(clk,res,delta,dcdb);
	input 	clk,res;
	input signed [31:0] delta;
	output signed[31:0] 	dcdb;
	
	reg[3:0]		q;
//	reg signed[31:0]	dcdb;
	reg signed[31:0]	delta_1,delta_2,delta_3,delta_4;
//	reg signed[31:0]	eta = 32'b0000_0001_0000_0000_0000_0000_0000_0000;
//	reg signed [31:0] eta;
	reg signed[31:0]	eta = 32'b11111111111001100110011001100110;//eta=-0.1
	reg signed[63:0]	tmp_dcdb;
	
//	initial
//	begin
//		eta <= 32'b0000_0000_0001_1001_1001_1001_1001_1001;
//	end
	
	always@(posedge clk or posedge res) 
	begin
		if(res == 1'b1)
			q = 4'h0;
		else if(q == 4'h3)
			q = 4'h0;
		else
			q = q + 4'h1;
	end
	
	always@(posedge clk or posedge res)
	begin
		if(res == 1'b1)
		begin
			delta_1 = 0;
			delta_2 = 0;
			delta_3 = 0;
			delta_4 = 0;
		end
		else if(q == 4'h0)
			delta_1 = delta;
		else if(q == 4'h1)
			delta_2 = delta;
		else if(q == 4'h2)
			delta_3 = delta;
		else if(q == 4'h3)
			delta_4 = delta;
		else
			begin
			delta_1 = 0;
			delta_2 = 0;
			delta_3 = 0;
			delta_4 = 0;
		end
				
	end
	
	always@(posedge clk or posedge res) 
	begin
		if(res == 1'b1)
			tmp_dcdb = 0;
		else
			tmp_dcdb = eta * (delta_1 + delta_2 + delta_3 + delta_4);
	end	
	
	assign dcdb = tmp_dcdb[55:24];
		
endmodule
