`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    11:50:07 10/10/2017 
// Design Name: 
// Module Name:    dw_adder 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module dw_adder(clk,res,dw,dcdw3);
	input 	clk,res;
	input signed [31:0] dw;
	output signed[31:0] 	dcdw3;
	
	reg[3:0]		q;
//	reg signed[31:0]	dcdw3;
	reg signed[31:0]	delta3a2_1,delta3a2_2,delta3a2_3,delta3a2_4;
//	reg signed [31:0] eta;
	reg signed[31:0]	eta = 32'b11111111111001100110011001100110;//eta=-0.1
   //reg signed[31:0]	eta = 32'b0000_0000_0000_0000_0000_0000_0000_0001;	
	reg signed[63:0]	tmp_dcdw3;

//	initial
//	begin
//		eta <= 32'b0000_0000_0001_1001_1001_1001_1001_1001;
//	end

	always@(posedge clk or posedge res) 
	begin
		if(res == 1'b1)
			q = 4'h0;
		else if(q == 4'h3)
			q = 4'h0;
		else
			q = q + 4'h1;
	end
	
	always@(posedge clk or posedge res)
	begin
		if (res == 1'b1)
			begin
				delta3a2_1 = 32'd0;
				delta3a2_2 = 32'd0;
				delta3a2_3 = 32'd0;
				delta3a2_4 = 32'd0;
			end			
		else if(q == 4'h0)
			begin
				delta3a2_1 = dw;
			end	
		else if(q == 4'h1)
			begin
				delta3a2_2 = dw;
			end
		else if(q == 4'h2)
			begin	
				delta3a2_3 = dw;
			end
		else if(q == 4'h3)
			begin
				delta3a2_4 = dw;
			end
		else
			begin
				delta3a2_1 = 32'd0;
				delta3a2_2 = 32'd0;
				delta3a2_3 = 32'd0;
				delta3a2_4 = 32'd0;
			end					
	end
	
	
	always@(posedge clk or posedge res)
	begin
		if(res == 1'b1)
			tmp_dcdw3 = 0;
		else
			begin
				tmp_dcdw3 = eta * (delta3a2_1 + delta3a2_2 + delta3a2_3 + delta3a2_4);
			end
	end
	
	assign dcdw3 = tmp_dcdw3[55:24];

	
endmodule
