`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    10:25:57 10/19/2017 
// Design Name: 
// Module Name:    forward 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module forward(

	input clk,
	input reset,
	input din,
	input select_initial,
	input signed [31:0] cap_b2_1,
	input signed [31:0] cap_b2_2,
	input signed [31:0] cap_b2_3,
	input signed [31:0] cap_w2_11,
	input signed [31:0] cap_w2_12,
	input signed [31:0] cap_w2_13,
	input signed [31:0] cap_w2_21,
	input signed [31:0] cap_w2_22,
	input signed [31:0] cap_w2_23,
	input signed [31:0] cap_b3_1,
	input signed [31:0] cap_b3_2,
	input signed [31:0] cap_w3_11,
	input signed [31:0] cap_w3_12,
	input signed [31:0] cap_w3_21,
	input signed [31:0] cap_w3_22,
	input signed [31:0] cap_w3_31,
	input signed [31:0] cap_w3_32,
	output signed [31:0] b2_1,
	output signed [31:0] b2_2,
	output signed [31:0] b2_3,
	output signed [31:0] b3_1,
	output signed [31:0] b3_2,
	output signed [31:0] w2_11,
	output signed [31:0] w2_12,
	output signed [31:0] w2_13,
	output signed [31:0] w2_21,
	output signed [31:0] w2_22,
	output signed [31:0] w2_23,
	output signed [31:0] w3_11,
	output signed [31:0] w3_12,
	output signed [31:0] w3_21,
	output signed [31:0] w3_22,
	output signed [31:0] w3_31,
	output signed [31:0] w3_32,
	output signed [31:0] a2_1,
	output signed [31:0] a2_2,
	output signed [31:0] a2_3,
	output signed [31:0] a3_1,
	output signed [31:0] a3_2,
	output signed [31:0] k1,
	output signed [31:0] k2,
	output signed [31:0] t1,
	output signed [31:0] t2
    );

wire select_update;
wire [3:0] out;		//NbNɓ͂^
wire [31:0] k1, k2, t1, t2;
wire [7:0] z2_1, z2_2, z2_3;
wire [7:0] z3_1, z3_2;

//signal for delay
/*wire [31:0] a2_1_tmp, a2_2_tmp, a2_3_tmp;
wire [31:0] a2_1_tmp2, a2_2_tmp2, a2_3_tmp2;
wire [31:0] a2_1_tmp3, a2_2_tmp3, a2_3_tmp3;
wire [31:0] a2_1_tmp4, a2_2_tmp4, a2_3_tmp4;
wire [31:0] t1_tmp, t2_tmp;
wire [31:0] t1_tmp2, t2_tmp2;
wire [31:0] t1_tmp3, t2_tmp3;
wire [31:0] t1_tmp4, t2_tmp4;
wire [31:0] k1_tmp, k2_tmp;
wire [31:0] k1_tmp2, k2_tmp2;
wire [31:0] k1_tmp3, k2_tmp3;
wire [31:0] k1_tmp4, k2_tmp4;*/


counter COUNTER(.clk(clk), .reset(reset), .out(out));
k1	K1(.clk(clk), .din(din), .addr(out), .k1(k1));
k2	K2(.clk(clk), .din(din), .addr(out), .k2(k2));
t1	T1(.clk(clk), .din(din), .addr(out), .t1(t1));
t2	T2(.clk(clk), .din(din), .addr(out), .t2(t2));

selector	SELECTOR(.clk(clk), .reset(reset), .enable_update(select_update));

b2_1	B2_1(.clk(clk), .reset(reset), .db2_1(cap_b2_1), .select_initial(select_initial), .select_update(select_update), .b2_1(b2_1));
b2_2	B2_2(.clk(clk), .reset(reset), .db2_2(cap_b2_2), .select_initial(select_initial), .select_update(select_update), .b2_2(b2_2));
b2_3	B2_3(.clk(clk), .reset(reset), .db2_3(cap_b2_3), .select_initial(select_initial), .select_update(select_update), .b2_3(b2_3));

w2_11	W2_11(.clk(clk), .reset(reset), .dw2_11(cap_w2_11), .select_initial(select_initial), .select_update(select_update), .w2_11(w2_11));
w2_12	W2_12(.clk(clk), .reset(reset), .dw2_12(cap_w2_12), .select_initial(select_initial), .select_update(select_update), .w2_12(w2_12));
w2_13	W2_13(.clk(clk), .reset(reset), .dw2_13(cap_w2_13), .select_initial(select_initial), .select_update(select_update), .w2_13(w2_13));
w2_21	W2_21(.clk(clk), .reset(reset), .dw2_21(cap_w2_21), .select_initial(select_initial), .select_update(select_update), .w2_21(w2_21));
w2_22	W2_22(.clk(clk), .reset(reset), .dw2_22(cap_w2_22), .select_initial(select_initial), .select_update(select_update), .w2_22(w2_22));
w2_23	W2_23(.clk(clk), .reset(reset), .dw2_23(cap_w2_23), .select_initial(select_initial), .select_update(select_update), .w2_23(w2_23));

b3_1	B3_1(.clk(clk), .reset(reset), .db3_1(cap_b3_1), .select_initial(select_initial), .select_update(select_update), .b3_1(b3_1));
b3_2	B3_2(.clk(clk), .reset(reset), .db3_2(cap_b3_2), .select_initial(select_initial), .select_update(select_update), .b3_2(b3_2));

w3_11	W3_11(.clk(clk), .reset(reset), .dw3_11(cap_w3_11), .select_initial(select_initial), .select_update(select_update), .w3_11(w3_11));
w3_12	W3_12(.clk(clk), .reset(reset), .dw3_12(cap_w3_12), .select_initial(select_initial), .select_update(select_update), .w3_12(w3_12));
w3_21	W3_21(.clk(clk), .reset(reset), .dw3_21(cap_w3_21), .select_initial(select_initial), .select_update(select_update), .w3_21(w3_21));
w3_22	W3_22(.clk(clk), .reset(reset), .dw3_22(cap_w3_22), .select_initial(select_initial), .select_update(select_update), .w3_22(w3_22));
w3_31	W3_31(.clk(clk), .reset(reset), .dw3_31(cap_w3_31), .select_initial(select_initial), .select_update(select_update), .w3_31(w3_31));
w3_32	W3_32(.clk(clk), .reset(reset), .dw3_32(cap_w3_32), .select_initial(select_initial), .select_update(select_update), .w3_32(w3_32));

z2	Z2_1(.clk(clk), .reset(reset), .k1(k1), .k2(k2), .w2_1(w2_11), .w2_2(w2_21), .b2(b2_1), .z2(z2_1));
z2	Z2_2(.clk(clk), .reset(reset), .k1(k1), .k2(k2), .w2_1(w2_12), .w2_2(w2_22), .b2(b2_2), .z2(z2_2));
z2	Z2_3(.clk(clk), .reset(reset), .k1(k1), .k2(k2), .w2_1(w2_13), .w2_2(w2_23), .b2(b2_3), .z2(z2_3));

mem	A2_1(.clk(clk), .din(din), .addr(z2_1), .dout(a2_1));
mem	A2_2(.clk(clk), .din(din), .addr(z2_2), .dout(a2_2));
mem	A2_3(.clk(clk), .din(din), .addr(z2_3), .dout(a2_3));

z3	Z3_1(.clk(clk), .reset(reset), .a2_1(a2_1), .a2_2(a2_2), .a2_3(a2_3), .w3_1(w3_11), .w3_2(w3_21), .w3_3(w3_31), .b3(b3_1), .z3(z3_1));
z3	Z3_2(.clk(clk), .reset(reset), .a2_1(a2_1), .a2_2(a2_2), .a2_3(a2_3), .w3_1(w3_12), .w3_2(w3_22), .w3_3(w3_32), .b3(b3_2), .z3(z3_2));

mem	A3_1(.clk(clk), .din(din), .addr(z3_1), .dout(a3_1));
mem	A3_2(.clk(clk), .din(din), .addr(z3_2), .dout(a3_2));

/*delay A2_1_tmp(.clk(clk), .inputdata(a2_1_tmp4), .outputdata(a2_1_tmp3));		//a2 : one clock delay
delay A2_2_tmp(.clk(clk), .inputdata(a2_2_tmp4), .outputdata(a2_2_tmp3));
delay A2_3_tmp(.clk(clk), .inputdata(a2_3_tmp4), .outputdata(a2_3_tmp3));

delay A2_1_tmp2(.clk(clk), .inputdata(a2_1_tmp3), .outputdata(a2_1_tmp2));		//a2 : two clock delay
delay A2_2_tmp2(.clk(clk), .inputdata(a2_2_tmp3), .outputdata(a2_2_tmp2));
delay A2_3_tmp2(.clk(clk), .inputdata(a2_3_tmp3), .outputdata(a2_3_tmp2));*/

/*delay A2_1_tmp3(.clk(clk), .inputdata(a2_1_tmp2), .outputdata(a2_1_tmp));		//a2 : three clock delay
delay A2_2_tmp3(.clk(clk), .inputdata(a2_2_tmp2), .outputdata(a2_2_tmp));
delay A2_3_tmp3(.clk(clk), .inputdata(a2_3_tmp2), .outputdata(a2_3_tmp));

delay A2_1_tmp4(.clk(clk), .inputdata(a2_1_tmp), .outputdata(a2_1));				//a2 : four clock delay
delay A2_2_tmp4(.clk(clk), .inputdata(a2_2_tmp), .outputdata(a2_2));
delay A2_3_tmp4(.clk(clk), .inputdata(a2_3_tmp), .outputdata(a2_3));

delay T1_tmp(.clk(clk), .inputdata(t1_tmp4), .outputdata(t1_tmp3));			//t: one clock delay
delay T2_tmp(.clk(clk), .inputdata(t2_tmp4), .outputdata(t2_tmp3));

delay T1_tmp2(.clk(clk), .inputdata(t1_tmp3), .outputdata(t1_tmp2));			//t: two clock delay
delay T2_tmp2(.clk(clk), .inputdata(t2_tmp3), .outputdata(t2_tmp2));

delay T1_tmp3(.clk(clk), .inputdata(t1_tmp2), .outputdata(t1_tmp));			//t: three clock delay
delay T2_tmp3(.clk(clk), .inputdata(t2_tmp2), .outputdata(t2_tmp));

delay T1_tmp4(.clk(clk), .inputdata(t1_tmp), .outputdata(t1));					//t: four clock delay
delay T2_tmp4(.clk(clk), .inputdata(t2_tmp), .outputdata(t2));

delay K1_tmp(.clk(clk), .inputdata(k1_tmp4), .outputdata(k1_tmp3));			//k: one clock delay
delay K2_tmp(.clk(clk), .inputdata(k2_tmp4), .outputdata(k2_tmp3));

delay K1_tmp2(.clk(clk), .inputdata(k1_tmp3), .outputdata(k1_tmp2));			//k: two clock delay
delay K2_tmp2(.clk(clk), .inputdata(k2_tmp3), .outputdata(k2_tmp2));

delay K1_tmp3(.clk(clk), .inputdata(k1_tmp2), .outputdata(k1_tmp));			//k: three clock delay
delay K2_tmp3(.clk(clk), .inputdata(k2_tmp2), .outputdata(k2_tmp));

delay K1_tmp4(.clk(clk), .inputdata(k1_tmp), .outputdata(k1));					//k: four clock delay
delay K2_tmp4(.clk(clk), .inputdata(k2_tmp), .outputdata(k2));*/
endmodule
